//------------------------------------------------------------------------------
// SetColorControls.java:
//		Implementation of "control creator" class SetColorControls
//------------------------------------------------------------------------------
import java.awt.*;
import DialogLayout;

public class SetColorControls
{
	Container    m_Parent       = null;
	boolean      m_fInitialized = false;
	DialogLayout m_Layout;

	// Control definitions
	//--------------------------------------------------------------------------
	Button        OkButton;
	Button        CancelButton;
	Scrollbar     RedScrollbar;
	Label         IDC_STATIC1;
	Label         IDC_STATIC2;
	Scrollbar     GreenScrollbar;
	Scrollbar     BlueScrollbar;
	Label         IDC_STATIC3;
	Label         IDC_STATIC4;
	Choice        StandardColorChoice;
	Label         RedValue;
	Label         GreenValue;
	Label         BlueValue;


	// Constructor
	//--------------------------------------------------------------------------
	public SetColorControls (Container parent)
	{
		m_Parent = parent;
	}

	// Initialization.
	//--------------------------------------------------------------------------
	public boolean CreateControls()
	{
		// CreateControls should be called only once
		//----------------------------------------------------------------------
		if (m_fInitialized || m_Parent == null)
			return false;

		// m_Parent must be extended from the Container class
		//----------------------------------------------------------------------
		if (!(m_Parent instanceof Container))
			return false;

		// Since a given font may not be supported across all platforms, it
		// is safe to modify only the size of the font, not the typeface.
		//----------------------------------------------------------------------
	    Font OldFnt = m_Parent.getFont();
	    if (OldFnt != null)
	    {
			Font NewFnt = new Font(OldFnt.getName(), OldFnt.getStyle(), 8);

    		m_Parent.setFont(NewFnt);
	    }

		// All position and sizes are in dialog logical units, so we use a
		// DialogLayout as our layout manager.
		//----------------------------------------------------------------------
		m_Layout = new DialogLayout(m_Parent, 220, 116);
		m_Parent.setLayout(m_Layout);
		m_Parent.addNotify();

		Dimension size   = m_Layout.getDialogSize();
		Insets    insets = m_Parent.insets();
		
		m_Parent.resize(insets.left + size.width  + insets.right,
                        insets.top  + size.height + insets.bottom);

		// Control creation
		//----------------------------------------------------------------------
		OkButton = new Button ("OK");
		m_Parent.add(OkButton);
		m_Layout.setShape(OkButton, 111, 98, 50, 14);

		CancelButton = new Button ("Cancel");
		m_Parent.add(CancelButton);
		m_Layout.setShape(CancelButton, 166, 98, 50, 14);

		RedScrollbar = new Scrollbar (Scrollbar.HORIZONTAL, 0, 1, 0, 99);
		m_Parent.add(RedScrollbar);
		m_Layout.setShape(RedScrollbar, 39, 10, 136, 11);

		IDC_STATIC1 = new Label ("Red", Label.LEFT);
		m_Parent.add(IDC_STATIC1);
		m_Layout.setShape(IDC_STATIC1, 10, 11, 28, 8);

		IDC_STATIC2 = new Label ("Green", Label.LEFT);
		m_Parent.add(IDC_STATIC2);
		m_Layout.setShape(IDC_STATIC2, 10, 24, 28, 8);

		GreenScrollbar = new Scrollbar (Scrollbar.HORIZONTAL, 0, 1, 0, 99);
		m_Parent.add(GreenScrollbar);
		m_Layout.setShape(GreenScrollbar, 39, 23, 136, 11);

		BlueScrollbar = new Scrollbar (Scrollbar.HORIZONTAL, 0, 1, 0, 99);
		m_Parent.add(BlueScrollbar);
		m_Layout.setShape(BlueScrollbar, 39, 36, 136, 11);

		IDC_STATIC3 = new Label ("Blue", Label.LEFT);
		m_Parent.add(IDC_STATIC3);
		m_Layout.setShape(IDC_STATIC3, 10, 37, 28, 8);

		IDC_STATIC4 = new Label ("Set Color To:", Label.LEFT);
		m_Parent.add(IDC_STATIC4);
		m_Layout.setShape(IDC_STATIC4, 11, 62, 50, 8);

		StandardColorChoice = new Choice ();
		m_Parent.add(StandardColorChoice);
		m_Layout.setShape(StandardColorChoice, 75, 60, 87, 52);

		RedValue = new Label ("0", Label.LEFT);
		m_Parent.add(RedValue);
		m_Layout.setShape(RedValue, 190, 11, 18, 8);

		GreenValue = new Label ("0", Label.LEFT);
		m_Parent.add(GreenValue);
		m_Layout.setShape(GreenValue, 190, 24, 18, 8);

		BlueValue = new Label ("0", Label.LEFT);
		m_Parent.add(BlueValue);
		m_Layout.setShape(BlueValue, 190, 37, 18, 8);

		m_fInitialized = true;
		return true;
	}
}
